955. Delete Columns to Make Sorted II
We are given an array A
of N
lowercase letter strings, all of the same length.
Now, we may choose any set of deletion indices, and for each string, we delete all the characters in those indices.
For example, if we have an array A = ["abcdef","uvwxyz"]
and deletion indices {0, 2, 3}
, then the final array after deletions is ["bef","vyz"]
.
Suppose we chose a set of deletion indices D
such that after deletions, the final array has its elements in lexicographic order (A[0] <= A[1] <= A[2] ... <= A[A.length - 1]
).
Return the minimum possible value of D.length
.
Example 1:
Input: ["ca","bb","ac"]
Output: 1
Explanation:
After deleting the first column, A = ["a", "b", "c"].
Now A is in lexicographic order (ie. A[0] <= A[1] <= A[2]).
We require at least 1 deletion since initially A was not in lexicographic order, so the answer is 1.
Example 2:
Input: ["xc","yb","za"]
Output: 0
Explanation:
A is already in lexicographic order, so we don't need to delete anything.
Note that the rows of A are not necessarily in lexicographic order:
ie. it is NOT necessarily true that (A[0][0] <= A[0][1] <= ...)
Example 3:
Input: ["zyx","wvu","tsr"]
Output: 3
Explanation:
We have to delete every column.
Note:
1 <= A.length <= 100
1 <= A[i].length <= 100
Appraoch #1: C++.
class Solution { public: int minDeletionSize(vector<string>& A) { int N = A.size(); int W = A[0].length(); int ans = 0; vector<string> temp(N, ""); for (int i = 0; i < W; ++i) { vector<string> cur = temp; for (int j = 0; j < N; ++j) { cur[j] += A[j][i]; } if (isSorted(cur)) temp = cur; else ans++; } return ans; } private: bool isSorted(vector<string> str) { for (int i = 1; i < str.size(); ++i) { if (str[i] < str[i-1]) return false; } return true; } };
Analysis:
we use a container to store the lexicographic, In each time we check whether the lexicographic string add the current columns contenting the statement. If yes, we add the currrent char to the lexicographic. If no, the answer +1.
Complexity Analysis
Time Complexity: O(NW^2), where NN is the length of A
, and WW is the length of A[i]
.
Space Complexity: O(NW).
953. Verifying an Alien Dictionary
In an alien language, surprisingly they also use english lowercase letters, but possibly in a different order
. The order
of the alphabet is some permutation of lowercase letters.
Given a sequence of words
written in the alien language, and the order
of the alphabet, return true
if and only if the given words
are sorted lexicographicaly in this alien language.
Example 1:
Input: words = ["hello","leetcode"], order = "hlabcdefgijkmnopqrstuvwxyz"
Output: true
Explanation: As 'h' comes before 'l' in this language, then the sequence is sorted.
Example 2:
Input: words = ["word","world","row"], order = "worldabcefghijkmnpqstuvxyz"
Output: false
Explanation: As 'd' comes after 'l' in this language, then words[0] > words[1], hence the sequence is unsorted.
Example 3:
Input: words = ["apple","app"], order = "abcdefghijklmnopqrstuvwxyz"
Output: false
Explanation: The first three characters "app" match, and the second string is shorter (in size.) According to lexicographical rules "apple" > "app", because 'l' > '∅', where '∅' is defined as the blank character which is less than any other character (More info).
Note:
1 <= words.length <= 100
1 <= words[i].length <= 20
order.length == 26
- All characters in
words[i]
andorder
are english lowercase letters.
Approach #2: C++.
class Solution { public: bool isAlienSorted(vector<string>& words, string order) { int mapping[26]; for (int i = 0; i < order.length(); ++i) { mapping[order[i]-'a'] = i; } for (auto& word : words) { for (auto& c : word) { c = mapping[c-'a']; } } return is_sorted(words.begin(), words.end()); } };
Analysis:
954. Array of Doubled Pairs
Given an array of integers A
with even length, return true
if and only if it is possible to reorder it such that A[2 * i + 1] = 2 * A[2 * i]
for every 0 <= i < len(A) / 2
.
Example 1:
Input: [3,1,3,6]
Output: false
Example 2:
Input: [2,1,2,6]
Output: false
Example 3:
Input: [4,-2,2,-4]
Output: true
Explanation: We can take two groups, [-2,-4] and [2,4] to form [-2,-4,2,4] or [2,4,-2,-4].
Example 4:
Input: [1,2,4,16,8,4]
Output: false
Note:
0 <= A.length <= 30000
A.length
is even-100000 <= A[i] <= 100000
Approach #1: C++.
class Solution { public: bool canReorderDoubled(vector<int>& A) { int len = A.size(); unordered_map<int, int> mp; for (int i = 0; i < len; ++i) { mp[A[i]]++; } sort(A.begin(), A.end()); for (int i = 0; i < len; ++i) { if (mp[A[i]] > 0) { if (mp[2*A[i]] > 0) { mp[A[i]]--; mp[2*A[i]]--; } } } for (int i = 0; i < len; ++i) { if (mp[A[i]] > 0) return false; } return true; } };
Analysis:
956. Tallest Billboard(can't understand)
You are installing a billboard and want it to have the largest height. The billboard will have two steel supports, one on each side. Each steel support must be an equal height.
You have a collection of rods
which can be welded together. For example, if you have rods of lengths 1, 2, and 3, you can weld them together to make a support of length 6.
Return the largest possible height of your billboard installation. If you cannot support the billboard, return 0.
Example 1:
Input: [1,2,3,6]
Output: 6
Explanation: We have two disjoint subsets {1,2,3} and {6}, which have the same sum = 6.
Example 2:
Input: [1,2,3,4,5,6]
Output: 10
Explanation: We have two disjoint subsets {2,3,5} and {4,6}, which have the same sum = 10.
Example 3:
Input: [1,2]
Output: 0
Explanation: The billboard cannot be supported, so we return 0.
Note:
0 <= rods.length <= 20
1 <= rods[i] <= 1000
The sum of rods is at most 5000.
Appraoch #1: C++.
class Solution { public: int tallestBillboard(vector<int>& rods) { unordered_map<int, int> dp; dp[0] = 0; for (int x : rods) { unordered_map<int, int> cur(dp); for (auto it : cur) { int d = it.first; dp[d+x] = max(dp[d+x], cur[d]); dp[abs(d-x)] = max(dp[abs(d-x)], cur[d] + min(d, x)); } } return dp[0]; } };